=== debian/changelog ===
emacs25 (25.2+1-6) unstable; urgency=high

  * Block remote code execution via enriched text.  Add
    0012-A-remote-execution-exploit-via-enriched-text-has-bee.patch to
    fix the problem.  Thanks to David Bremner for the alert and
    Salvatore Bonaccorso for reporting the problem to Debian.
    (Closes: 875447)

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 11 Sep 2017 21:51:49 -0500

emacs25 (25.2+1-5) unstable; urgency=medium

  * Build with -O0 on arm64 to avoid FTBS.  Without this the build
    segfaults in marker.c when trying to construct c-by.el.
    cf. https://lists.gnu.org/archive/html/emacs-devel/2017-03/msg00798.html
    Thanks to Gianfranco Costamagna for reporting the bug and Barry
    Warsaw for suggesting the workaround. (Closes: 868165)

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 31 Jul 2017 23:34:05 -0500

emacs25 (25.2+1-4) unstable; urgency=medium

  * Disable eieio-test-method-order-list-6.  Its behavior is
    unpredictable, and it was causing the armhf build to fail:
      https://debbugs.gnu.org/27878
      https://debbugs.gnu.org/24503#21
    Add 0011-Disable-eieio-test-method-order-list-6.patch to fix the
    problem.  Thanks to Glen Morris for pointing out the previous report.

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 30 Jul 2017 22:31:30 -0500

emacs25 (25.2+1-3) unstable; urgency=medium

  * Actually run tests by default (fix DEB_BUILD_OPTIONS nocheck test)
    Fix the inverted logic.  Thanks to John Paul Adrian Glaubitz for
    reporting the problem.  (Closes: 869328)

  * Completely remove gconf support.  Build --without-gconf for the
    emacs25 flavor (as we already do for lucid and nox), since GConf
    has been deprecated for years.  Thanks to intrigeri for reporting
    the issue. (Closes: 869085)

  * Fix README.Debian news entry for
    0008-Don-t-provide-openssl-s_client-as-an-option-for-ssl-.patch.

  * Fix memory alignment problem causing FTBS on m68k.  Thanks to John
    Paul Adrian Glaubitz for reporting the problem and providing an
    earlier fix. (Closes: 868868)

  * Don't downcase lookup paths in elisp-mode-tests.  This caused the
    tests to fail under sbuild when the test path contained uppercase
    characters.  Add
    0010-Don-t-downcase-real-xref-in-elisp-mode-tests.patch to fix the
    problem.

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 29 Jul 2017 11:58:36 -0500

emacs25 (25.2+1-2) unstable; urgency=medium

  * emacsXY-common: directly depend on install-info.  Since Emacs
    qualifies as an info reader (Debian Policy 12.2).  This should
    make sure the info index is correctly created/updated at install
    time.  Thanks to Francesco Potortì and NIIBE Yutaka for reporting
    the problem. (Closes: 850808, 863359)

  * Build all flavors from common build-src via VPATH.  Instead of
    building each flavor from scratch in a completely independent
    debian/build-FLAVOR directory, create debian/build-src and then
    configure each build-FLAVOR via VPATH.  Then the first flavor
    built will handle all of the common bootstrapping, and subsequent
    flavors will build much more quickly.

  * Migrate to debhelper 10.

 -- Rob Browning <rlb@defaultvalue.org>  Tue, 11 Jul 2017 15:46:35 -0500

emacs25 (25.2+1-1) unstable; urgency=medium

  * Merge upstream version 25.2.

  * Update debian/ for 25.2.

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 01 Jul 2017 14:35:18 -0500
